<?php
$ip = "localhost";
$port = 9999; //UDP port on server
$timeout = 2; //Timeout in seconds

$msg_out = "";
$msg_debug = "";

if (isset($_POST["cmd"])) {

    $cmd = $_POST["cmd"];

    if ($cmd == "CMD:LED=1" || $cmd == "CMD:LED=0" || $cmd == "CMD:INFO") {
        $sock = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
        socket_set_option($sock, SOL_SOCKET, SO_BROADCAST, 1);
        socket_set_option($sock, SOL_SOCKET, SO_RCVTIMEO,
                array("sec" => $timeout, "usec" => 0));
        socket_sendto($sock, $cmd, strlen($cmd), 0, $ip, $port);

        while (true) {
            $ret = @socket_recvfrom($sock, $buf, 1024, 0, $ip, $port);
            if ($ret === false) {
                break;
            }
            if (strpos($buf, "DONE") !== false) {
                $msg_out = "Arduino switched LED successful!";
            } else if (strpos($buf, "MSG-DEV:") !== false) {
                $msg_out = $buf;
            } else {
                $msg_out = "Error!";
            }
            $msg_debug .= "UDP Message: < $buf ><br>";
        }
        socket_close($sock);
    }
}
?>

<!DOCTYPE html>
<html>
    <body>
        <h1>PHP UDP Controller</h1>
        <p><?php echo $msg_out ?></p>
        <br>
        <form action="" method="POST">
            <button type="submit" name="cmd" value="CMD:LED=1">LED ON</button>
            <button type="submit" name="cmd" value="CMD:LED=0">LED OFF</button>
            <button type="submit" name="cmd" value="CMD:INFO">INFO</button>
        </form>
        <br>
        <small>Received Response from Server (RAW):</small><br>
        <small><?php echo $msg_debug ?></small>
    </body>
</html>
